"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const oaf_routing_1 = require("oaf-routing");
exports.defaultSettings = Object.assign({}, oaf_routing_1.defaultSettings);
exports.wrapRouter = (router, 
// HACK instanceof doesn't work across require() boundary
isNavigationEndEvent, settingsOverrides) => {
    const settings = Object.assign({}, exports.defaultSettings, { 
        // TODO support pop page state restoration.
        restorePageStateOnPop: false, 
        // We're not restoring page state ourselves so leave this enabled.
        disableAutoScrollRestoration: false }, settingsOverrides);
    const oafRouter = oaf_routing_1.createOafRouter(settings, navigation => {
        const fragment = (navigation.finalUrl || navigation.extractedUrl).fragment;
        return fragment !== null ? `#${fragment}` : "";
    });
    const initialNavigation = router.getCurrentNavigation();
    if (initialNavigation !== null) {
        oafRouter.handleFirstPageLoad(initialNavigation);
    }
    const subscription = router.events.subscribe(event => {
        if (isNavigationEndEvent(event)) {
            const navigation = router.getCurrentNavigation();
            const previousNavigation = navigation !== null ? navigation.previousNavigation : null;
            if (navigation !== null && previousNavigation !== null) {
                oafRouter.handleLocationChanged(previousNavigation, navigation, undefined, undefined);
            }
        }
    });
    return () => {
        oafRouter.resetAutoScrollRestoration();
        subscription.unsubscribe();
    };
};
